﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Windows.Forms;
using HeuristicLab.Core;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;

namespace HeuristicLab.Clients.Hive.Administration.Views {
  [View("HiveAdministrationView")]
  [Content(typeof(HiveAdministrationClient), IsDefaultView = true)]
  public partial class HiveAdministrationView : ItemView {
    public new HiveAdministrationClient Content {
      get { return (HiveAdministrationClient)base.Content; }
      set { base.Content = value; }
    }

    public HiveAdministrationView() {
      InitializeComponent();
    }

    #region Register Content Events
    protected override void DeregisterContentEvents() {
      // TODO: Deregister your event handlers on the Content here
      base.DeregisterContentEvents();
    }
    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
      // TODO: Register your event handlers on the Content here
    }
    #endregion

    private void UpdateResources() {
      IItemList<Resource> resources = new ItemList<Resource>();

      foreach (SlaveGroup g in Content.SlaveGroups) {
        resources.Add(g);
      }
      foreach (Slave g in Content.Slaves) {
        resources.Add(g);
      }
      resourcesView.Content = resources;
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        resourcesView.Content = null;

      } else {
        //updateSlaveGroups.UpdateAction = new Action(Content.UpdateSlaveGroups);  //??
        UpdateResources();

        ShowUsers();
      }
    }

    private void ShowUsers() {
      lstUsers.SmallImageList.Images.Add(HeuristicLab.Common.Resources.VSImageLibrary.User);

      foreach (string user in Content.Users) {
        ListViewItem lvi = new ListViewItem();
        lvi.Tag = user;
        lvi.Text = user;
        lvi.ImageIndex = 0;
        lstUsers.Items.Add(lvi);
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      // TODO: Put code here to enable or disable controls based on whether the Content is/not null or the view is ReadOnly
    }

    private void HiveAdministrationView_Load(object sender, System.EventArgs e) {
      if (Content != null) {

      }
    }

    #region Event Handlers
    // TODO: Put event handlers here
    #endregion
  }
}
